package sample.persistence.dao;

import java.util.List;

import org.seasar.dao.annotation.tiger.Arguments;
import org.seasar.dao.annotation.tiger.Query;
import org.seasar.dao.annotation.tiger.S2Dao;

import sample.persistence.entity.Item;

@S2Dao(bean=Item.class)
public interface ItemDao {

	@Arguments({"itemCode"})
	@Query("ITEM_CODE = /*itemCode*/")
	public Item select(String itemCode);
	
	@Query("ORDER BY ITEM_CODE")
	public List<Item> selectAll();
	
	@Arguments({"itemCode"})
	@Query("ITEM_CODE LIKE /*itemCode*/ ORDER BY ITEM_CODE")
	public List<Item> selectLike(String itemCode);

	public void insert(Item item);
	
	public void update(Item item);
	
	public void delete(Item item);
	
}
