package sample.persistence.dao;

import java.util.List;

import org.seasar.dao.annotation.tiger.Arguments;
import org.seasar.dao.annotation.tiger.Query;
import org.seasar.dao.annotation.tiger.S2Dao;

import sample.persistence.entity.OrderDetail;

@S2Dao(bean=OrderDetail.class)
public interface OrderDetailDao {

	@Arguments({"orderNo", "detailNo"})
	@Query("ORDER_NO = /*orderNo*/ AND DETAIL_NO = /*detailNo*/")
	public OrderDetail select(int orderNo, int no);
	
	@Arguments({"orderNo"})
	@Query("ORDER_NO = /*orderNo*/ ORDER BY DETAIL_NO")
	public List<OrderDetail> selectByOrderNo(int orderNo);
	
	public void insert(OrderDetail orderItem);

}
