package sample.persistence.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.seasar.dao.annotation.tiger.Id;
import org.seasar.dao.annotation.tiger.IdType;

public class ItemOrder extends Entity {

	@Id(value=IdType.IDENTITY)
	private int orderNo;
	
	private String customerName;
	
	private Date orderDate;
	
	private List<OrderDetail> orderDetails = new ArrayList<OrderDetail>();

	public int getTotalAmount() {
		int totalAmount = 0;
		for (OrderDetail detail : orderDetails) {
			totalAmount += detail.getAmount();
		}
		return totalAmount;
	}
		
	public void addOrderDetail(OrderDetail orderDetail) {
		orderDetail.setOrderNo(orderNo);
		orderDetail.setDetailNo(orderDetails.size() + 1);
		orderDetails.add(orderDetail);
	}
	
	public List<OrderDetail> getOrderDetails() {
		return orderDetails;
	}

	public void setOrderDetails(List<OrderDetail> orderDetails) {
		this.orderDetails.addAll(orderDetails);
	}

	public int getOrderNo() {
		return orderNo;
	}

	public void setOrderNo(int orderNo) {
		this.orderNo = orderNo;
		for (OrderDetail detail : orderDetails) {
			detail.setOrderNo(orderNo);
		}
	}

	public String getCustomerName() {
		return customerName;
	}

	public void setCustomerName(String customerName) {
		this.customerName = customerName;
	}

	public Date getOrderDate() {
		return orderDate;
	}

	public void setOrderDate(Date orderDate) {
		this.orderDate = orderDate;
	}
	
}
