package sample.persistence.service.impl;

import java.util.List;

import sample.persistence.dao.ItemDao;
import sample.persistence.entity.Item;
import sample.persistence.service.ItemService;

public class ItemServiceImpl implements ItemService {

	public ItemDao itemDao;
	
	public Item find(String itemCode) {
		return itemDao.select(itemCode);
	}

	public List<Item> all() {
		return itemDao.selectAll();
	}
	
	public List<Item> findLike(String itemCode) {
		return itemDao.selectLike("%" + itemCode + "%");
	}

	public void save(Item item) {
		if (item.isPersisted()) {
			itemDao.update(item);
		} else {
			itemDao.insert(item);
		}
	}

	public void delete(Item item) {
		itemDao.delete(item);
	}

}
