package sample.persistence.service.impl;

import java.util.Date;
import java.util.List;

import sample.persistence.dao.ItemOrderDao;
import sample.persistence.dao.OrderDetailDao;
import sample.persistence.entity.ItemOrder;
import sample.persistence.entity.OrderDetail;
import sample.persistence.service.OrderService;

public class OrderServiceImpl implements OrderService {

	public ItemOrderDao itemOrderDao;

	public OrderDetailDao orderDetailDao;
	
	public List<ItemOrder> all() {
		return itemOrderDao.selectAll();
	}

	public ItemOrder find(int orderNo) {
		/* ̌ */
		ItemOrder order = itemOrderDao.select(orderNo);
		
		if (order != null) {
			/* ׂ̌ */
			order.setOrderDetails(orderDetailDao.selectByOrderNo(orderNo));
		}
		
		return order;
	}

	public void register(ItemOrder order) {
		order.setOrderDate(new Date());
		
		/* ̕ۑ */
		itemOrderDao.insert(order);

		/* ׂ̕ۑ */
		for (OrderDetail detail : order.getOrderDetails()) {
			orderDetailDao.insert(detail);
		}
	}

}
