package sample.persistence.web;

import org.apache.wicket.AttributeModifier;
import org.apache.wicket.Component;
import org.apache.wicket.MarkupContainer;
import org.apache.wicket.Component.IVisitor;
import org.apache.wicket.markup.html.form.AbstractTextComponent;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.Model;

public class ComponentEnableVisitor implements IVisitor {

	private static final IModel ATTR_ADD = new Model(AttributeModifier.VALUELESS_ATTRIBUTE_ADD);

	private static final IModel ATTR_REMOVE = new Model(AttributeModifier.VALUELESS_ATTRIBUTE_REMOVE);

	private final boolean enable;
	
	private final boolean recursive;

	public ComponentEnableVisitor(boolean enable, boolean recursive) {
		this.enable = enable;
		this.recursive = recursive;
	}
	
	public Object component(Component comp) {
		if (comp instanceof AbstractTextComponent) {
			comp.add(new AttributeModifier("readonly",	true, enable ? ATTR_REMOVE : ATTR_ADD));
		} else {
			comp.setEnabled(enable);
		}
		
		if (recursive && comp instanceof MarkupContainer) {
			((MarkupContainer)comp).visitChildren(this);
		}
		
		return null;
	}

}
