package sample.persistence.web.item.page;

import java.util.List;

import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.link.BookmarkablePageLink;
import org.apache.wicket.markup.html.link.Link;
import org.apache.wicket.markup.html.list.ListItem;
import org.apache.wicket.markup.html.list.ListView;
import org.apache.wicket.markup.html.panel.FeedbackPanel;
import org.apache.wicket.model.CompoundPropertyModel;
import org.apache.wicket.model.Model;
import org.apache.wicket.util.convert.IConverter;

import sample.persistence.entity.Item;
import sample.persistence.service.ItemService;
import sample.persistence.web.PatternedSqlTimestampConverter;

public class ItemListPage extends WebPage {

	public transient ItemService itemService;
	
	public ItemListPage() {
		super();
		
		add(homePageLink("menu"));
		
		add(new BookmarkablePageLink("newItem", ItemPage.class));
		
		List<Item> items = itemService.all();
		
		/*
		 * MEMO f[^̈ꗗ\.
		 */
		add(new ListView("items", items) {
			private int no = 1;
			
			/*
			 * UIR|[lgɁAJava Bean oChɂ́Aȉ̂Q̕@.
			 */
			
//			/**
//			 * MEMO 1.PropertyModel gāAUIR|Ƀf̃vpeB𖾎IɃoChĂ@.
//			 */
//			@Override
//			protected void populateItem(ListItem item) {
//				final Item itemModel = (Item)item.getModelObject();
//				
//				item.add(new Label("no", new Model(no++)));
//
//				item.add(new Label("itemCode", new PropertyModel(itemModel, "itemCode")));
//				item.add(new Label("itemName", new PropertyModel(itemModel, "itemName")));
//				item.add(new Label("price", new PropertyModel(itemModel, "price")));
//				item.add(new Label("versionNo", new PropertyModel(itemModel, "versionNo")));
//				item.add(new Label("timestamp", new PropertyModel(itemModel, "timestamp")));
//
//				item.add(new Link("editItem") {
//					@Override
//					public void onClick() {
//						setResponsePage(new ItemPage(itemModel));
//					}
//				});
//			}
			
			/**
			 * MEMO 2.CompoundPropertyModel gāAUIR|Ƀf̃vpeBIɃoChĂ@.
			 * UIR|̃R|[lgIDƁAf̃vpeBvĂŗǂ.
			 */
			@Override
			protected void populateItem(ListItem item) {
				final Item itemModel = (Item)item.getModelObject();
				
				item.add(new Label("no", new Model(no++)));

				item.setModel(new CompoundPropertyModel(itemModel));
				item.add(new Label("itemCode"));
				item.add(new Label("itemName"));
				item.add(new Label("price"));
				item.add(new Label("versionNo"));
				item.add(new Label("timestamp") {
					/**
					 * MEMO Ro[^Aʂɐݒ肷.
					 */
					@SuppressWarnings("unchecked")
					@Override
					public IConverter getConverter(Class type) {
						return new PatternedSqlTimestampConverter("yy/MM/dd");
					}
				});
				
				item.add(new Link("editItem") {
					/**
					 * MEMO ꗗʂAIs̏ڍ׉ʂɑJڂ.
					 * ڍ׉ʂPageR|[lg̃RXgN^ɁAIꂽsModelZbg邾OK.
					 */
					@Override
					public void onClick() {
						setResponsePage(new ItemPage(itemModel));
					}
				});
			}
		});
		
		/*
		 * MEMO bZ[W\iFeedbackPaneljǉ.
		 */
		add(new FeedbackPanel("feedback"));
		
		/*
		 * MEMO bZ[WiINFOjݒ.
		 */
		info(" " + items.size() + " ̏io^Ă܂.");
	}
	
}
