package sample.persistence.web.item.page;

import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.form.Button;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.form.RequiredTextField;
import org.apache.wicket.markup.html.link.BookmarkablePageLink;
import org.apache.wicket.markup.html.panel.FeedbackPanel;
import org.apache.wicket.model.CompoundPropertyModel;
import org.apache.wicket.model.StringResourceModel;

import sample.persistence.entity.Item;
import sample.persistence.service.ItemService;

public class ItemPage extends WebPage {

	private Item item;
	
	public transient ItemService itemServie;
	
	/**
	 * MEMO ڍ׉ʂAVKo^ʂƂĊJꍇ.
	 */
	public ItemPage() {
		this(new Item());
	}

	/**
	 * MEMO ڍ׉ʂAҏWʂƂĊJꍇ.
	 * 
	 * @param item ҏW鏤i
	 */
	public ItemPage(Item item) {
		super();
		
		this.item = item;
		
		add(new Label("window.title", new StringResourceModel("window.title", this, null)));
		
		add(new Label("title", new StringResourceModel("title", this, null)));
		add(new Label("message.internationalized", new StringResourceModel("message.internationalized", this, null)));
		add(homePageLink("menu")
			.add(new Label("text", new StringResourceModel("menu", this, null))));

		add(new BookmarkablePageLink("itemList", ItemListPage.class)
			.add(new Label("text", new StringResourceModel("itemList", this, null))));

		add(new EditItem("editItem"));
		
		add(new FeedbackPanel("feedback"));
	}
	
	
	public class EditItem extends Form {
		
		public EditItem(String id) {
			super(id);
			setModel(new CompoundPropertyModel(item));

			add(new Label("itemCode.text", new StringResourceModel("itemCode", this, null)));
			add(new RequiredTextField("itemCode") {
				@Override
				public boolean isEnabled() {
					return getModelObject() == null;
				}
			});
			
			add(new Label("itemName.text", new StringResourceModel("itemName", this, null)));
			add(new RequiredTextField("itemName"));
			
			add(new Label("price.text", new StringResourceModel("price", this, null)));
			add(new RequiredTextField("price", Integer.class));
			
			add(new Label("versionNo.text", new StringResourceModel("versionNo", this, null)));
			add(new Label("versionNo"));
			
			add(new Label("timestamp.text", new StringResourceModel("timestamp", this, null)));
			add(new Label("timestamp"));
			
			add(new Button("save", new StringResourceModel("save", this, null)) {
				@Override
				public void onSubmit() {
					itemServie.save(item);
					
					/*
					 * MEMO bZ[WiINFOjݒ.
					 */
					info(new StringResourceModel("message.saved", this, null).getString());
				}
			});
			
			add(new Button("delete", new StringResourceModel("delete", this, null)) {
				@Override
				public void onSubmit() {
					itemServie.delete(item);
					
					/*
					 * MEMO ڍ׉ʂAꗗʂɖ߂.
					 */
					setResponsePage(ItemListPage.class);
				}
			});
		}

	}
	
}
